rpmvf.h File Reference
`#include <rpm/rpmtypes.h>`
Include dependency graph for rpmvf.h:

Go to the source code of this file.

## Macros

#define | RPMVERIFY_ALL ~(RPMVERIFY_NONE)
#define | RPMVERIFY_FAILURES (RPMVERIFY_LSTATFAIL|RPMVERIFY_READFAIL|RPMVERIFY_READLINKFAIL|RPMVERIFY_LGETFILECONFAIL)
#define | VERIFY_ATTRS
#define | VERIFY_ALL

## Typedefs

typedef rpmFlags | rpmVerifyAttrs
typedef rpmFlags | rpmVerifyFlags

## Enumerations

enum

rpmVerifyAttrs_e {
RPMVERIFY_NONE = 0, RPMVERIFY_MD5 = (1 << 0), RPMVERIFY_FILEDIGEST = (1 << 0), RPMVERIFY_FILESIZE = (1 << 1),
RPMVERIFY_LINKTO = (1 << 2), RPMVERIFY_USER = (1 << 3), RPMVERIFY_GROUP = (1 << 4), RPMVERIFY_MTIME = (1 << 5),
RPMVERIFY_MODE = (1 << 6), RPMVERIFY_RDEV = (1 << 7), RPMVERIFY_CAPS = (1 << 8), RPMVERIFY_CONTEXTS = (1 << 15),
RPMVERIFY_READLINKFAIL = (1 << 28), RPMVERIFY_READFAIL = (1 << 29), RPMVERIFY_LSTATFAIL = (1 << 30), RPMVERIFY_LGETFILECONFAIL = (1 << 31)
}

| Bit(s) for rpmVerifyFile() attributes and result. More...

enum

rpmVerifyFlags_e {
VERIFY_DEFAULT = 0, VERIFY_MD5 = (1 << 0), VERIFY_FILEDIGEST = (1 << 0), VERIFY_SIZE = (1 << 1),
VERIFY_LINKTO = (1 << 2), VERIFY_USER = (1 << 3), VERIFY_GROUP = (1 << 4), VERIFY_MTIME = (1 << 5),
VERIFY_MODE = (1 << 6), VERIFY_RDEV = (1 << 7), VERIFY_CAPS = (1 << 8), VERIFY_CONTEXTS = (1 << 15),
VERIFY_FILES = (1 << 16), VERIFY_DEPS = (1 << 17), VERIFY_SCRIPT = (1 << 18), VERIFY_DIGEST = (1 << 19),
VERIFY_SIGNATURE = (1 << 20), VERIFY_PATCHES = (1 << 21), VERIFY_HDRCHK = (1 << 22), VERIFY_FOR_LIST = (1 << 23),
VERIFY_FOR_STATE = (1 << 24), VERIFY_FOR_DOCS = (1 << 25), VERIFY_FOR_CONFIG = (1 << 26), VERIFY_FOR_DUMPFILES = (1 << 27)
}

| Bit(s) to control rpmVerify() operation. More...

## Functions

int | rpmVerifyFile (const rpmts ts, rpmfi fi, rpmVerifyAttrs *res, rpmVerifyAttrs omitMask)
| Verify file attributes (including digest). More...

## Detailed Description

Todo:
  Add a more complete API...

Definition in file rpmvf.h.

## Macro Definition Documentation

#define RPMVERIFY_ALL ~(RPMVERIFY_NONE)

Definition at line 41 of file rpmvf.h.

#define RPMVERIFY_FAILURES (RPMVERIFY_LSTATFAIL|RPMVERIFY_READFAIL|RPMVERIFY_READLINKFAIL|RPMVERIFY_LGETFILECONFAIL)

Definition at line 42 of file rpmvf.h.

#define VERIFY_ALL

Value:
( VERIFY_ATTRS | VERIFY_FILES | VERIFY_DEPS | VERIFY_SCRIPT | VERIFY_DIGEST |\
VERIFY_SIGNATURE | VERIFY_HDRCHK )
VERIFY_DEPS
Definition: rpmvf.h:63
VERIFY_SIGNATURE
Definition: rpmvf.h:66
VERIFY_SCRIPT
Definition: rpmvf.h:64
VERIFY_DIGEST
Definition: rpmvf.h:65
VERIFY_HDRCHK
Definition: rpmvf.h:68
VERIFY_FILES
Definition: rpmvf.h:62
VERIFY_ATTRS
#define VERIFY_ATTRS
Definition: rpmvf.h:79

Definition at line 82 of file rpmvf.h.

Referenced by main().

#define VERIFY_ATTRS

Value:
( VERIFY_FILEDIGEST | VERIFY_SIZE | VERIFY_LINKTO | VERIFY_USER | VERIFY_GROUP | \
VERIFY_MTIME | VERIFY_MODE | VERIFY_RDEV | VERIFY_CONTEXTS | VERIFY_CAPS )
VERIFY_LINKTO
Definition: rpmvf.h:53
VERIFY_RDEV
Definition: rpmvf.h:58
VERIFY_GROUP
Definition: rpmvf.h:55
VERIFY_MODE
Definition: rpmvf.h:57
VERIFY_CAPS
Definition: rpmvf.h:59
VERIFY_CONTEXTS
Definition: rpmvf.h:61
VERIFY_USER
Definition: rpmvf.h:54
VERIFY_FILEDIGEST
Definition: rpmvf.h:51
VERIFY_SIZE
Definition: rpmvf.h:52
VERIFY_MTIME
Definition: rpmvf.h:56

Definition at line 79 of file rpmvf.h.

## Typedef Documentation

typedef rpmFlags rpmVerifyAttrs

Definition at line 39 of file rpmvf.h.

typedef rpmFlags rpmVerifyFlags

Definition at line 77 of file rpmvf.h.

## Enumeration Type Documentation

enum rpmVerifyAttrs_e

Bit(s) for rpmVerifyFile() attributes and result.

Enumerator
RPMVERIFY_NONE |
RPMVERIFY_MD5 | from verify(md5) - obsolete
RPMVERIFY_FILEDIGEST | from verify(filedigest)
RPMVERIFY_FILESIZE | from verify(size)
RPMVERIFY_LINKTO | from verify(link)
RPMVERIFY_USER | from verify(user)
RPMVERIFY_GROUP | from verify(group)
RPMVERIFY_MTIME | from verify(mtime)
RPMVERIFY_MODE | from verify(mode)
RPMVERIFY_RDEV | from verify(rdev)
RPMVERIFY_CAPS | from verify(caps)
RPMVERIFY_CONTEXTS | verify: from –nocontexts
RPMVERIFY_READLINKFAIL | readlink failed
RPMVERIFY_READFAIL | file read failed
RPMVERIFY_LSTATFAIL | lstat failed
RPMVERIFY_LGETFILECONFAIL | lgetfilecon failed

Definition at line 17 of file rpmvf.h.

enum rpmVerifyFlags_e

Bit(s) to control rpmVerify() operation.

Enumerator
VERIFY_DEFAULT |
VERIFY_MD5 | from –nomd5 - obsolete
VERIFY_FILEDIGEST | from –nofiledigest
VERIFY_SIZE | from –nosize
VERIFY_LINKTO | from –nolinkto
VERIFY_USER | from –nouser
VERIFY_GROUP | from –nogroup
VERIFY_MTIME | from –nomtime
VERIFY_MODE | from –nomode
VERIFY_RDEV | from –nodev
VERIFY_CAPS | from –nocaps
VERIFY_CONTEXTS | verify: from –nocontexts
VERIFY_FILES | verify: from –nofiles
VERIFY_DEPS | verify: from –nodeps
VERIFY_SCRIPT | verify: from –noscripts
VERIFY_DIGEST | verify: from –nodigest
VERIFY_SIGNATURE | verify: from –nosignature
VERIFY_PATCHES | verify: from –nopatches
VERIFY_HDRCHK | verify: from –nohdrchk
VERIFY_FOR_LIST | query: from –list
VERIFY_FOR_STATE | query: from –state
VERIFY_FOR_DOCS | query: from –docfiles
VERIFY_FOR_CONFIG | query: from –configfiles
VERIFY_FOR_DUMPFILES | query: from –dump

Definition at line 48 of file rpmvf.h.

## Function Documentation

int rpmVerifyFile | ( | const rpmts | ts,
|  | rpmfi | fi,
|  | rpmVerifyAttrs * | res,
|  | rpmVerifyAttrs | omitMask
| ) |  |

Verify file attributes (including digest).

Todo:
  gnorpm and python bindings prevent this from being static.
  Parameters

    ts | transaction set
    fi | file info (with linked header and current file index)

  Return values

    *res | bit(s) returned to indicate failure

  Parameters

    omitMask | bit(s) to disable verify checks

  Returns
    0 on success (or not installed), 1 on error